       PROGRAM MAP_NEURAL_MA_STEEL
       IMPLICIT NONE
C Calculation of properties of mechanically alloyed iron 
Copyright 1998, A. Y. Badmos and H. K. D. H. Bhadeshia
C University of Cambridge
C
C Materials Science and Technology, 1998, in press
C Ph.D. Thesis, A. Y. Badmos, University of Cambridge
C
      



      DOUBLE PRECISION AW(14),YSRES(26),UTSRES(26),ELRES(26)
      DOUBLE PRECISION AVER,SIGYS,SIGUTS,SIGEL
      INTEGER ID, IYES,JYES
 
	open(11,file="out")    
C
      IYES=2
      AVER=5.2   
      CALL LOGO(AVER,1)

2      IF(IYES .EQ. 2) CALL RCOMP(AW,ID)
C
C Calculate yield strength
      CALL YS(AW,YSRES,SIGYS)
      AW(14)=YSRES(6)
C
C Calculate ultimate tensile strength
      CALL UTS(AW,UTSRES,SIGUTS)
      AW(13)=UTSRES(4)

C
C Calculate elongation
      CALL ELONGATION(AW,ELRES,SIGEL)

C
      CALL WRITT(AW,ID,AVER)

      WRITE(*,900) YSRES(1),YSRES(2),YSRES(3),YSRES(4),YSRES(5)

      WRITE(*,901) UTSRES(1),UTSRES(2),UTSRES(3)

      WRITE(*,902) ELRES(1),ELRES(2),ELRES(3),ELRES(4),
     & ELRES(5),ELRES(6)

      WRITE(11,900) YSRES(1),YSRES(2),YSRES(3),YSRES(4),YSRES(5)

      WRITE(11,901) UTSRES(1),UTSRES(2),UTSRES(3)

      WRITE(11,902) ELRES(1),ELRES(2),ELRES(3),ELRES(4),
     & ELRES(5),ELRES(6)


   	PAUSE 'Press RETURN to continue'

       write(*,903)YSRES(6),2*SIGYS*YSRES(6),UTSRES(4),
     & 2*SIGUTS*UTSRES(4), ELRES(7),2*SIGEL*ELRES(7)
       write(*,1)
	
       write(11,903)YSRES(6),2*SIGYS*YSRES(6),UTSRES(4),
     & 2*SIGUTS*UTSRES(4), ELRES(7),2*SIGEL*ELRES(7)     
      WRITE(11,1)

   	PAUSE 'Press RETURN to continue'

      CALL RCOMP2(AW,JYES,IYES)
      IF(IYES .EQ. 0) THEN
          GOTO 3
        ELSE
          GOTO 2

      ENDIF

1     FORMAT(
     &/' *************************************************',
     &'*********************')
     
900   FORMAT(//2X,' Individual model Yield Strength (MPa):'
     &       /2X,5F7.0/)
  
901   FORMAT(2X,' Individual model Ultimate Strength (MPa):'
     &       /2X,3F7.0/)

902   FORMAT(2X,' Individual model elongations (%):'
     &       /2X,6F7.0/) 

903   FORMAT(
     & 20X,' Mean Yield Strength    = ',f7.0,' +- ', F4.0,'MPa'/
     & 20X,' Mean Ultimate Strength = ',f7.0,' +- ', F4.0,'MPa'/
     & 20X,' Mean Elongation        = ',f7.0,' +- ', F4.0, '%'//
     & ' The error bars (95% confidence) do not include '/
     & ' the uncertainty in fitting the data to the function,'/
     & ' simply the unexplained noise in the data.')

3     STOP
      END
C
C-------------------------------------------------------------
C
      SUBROUTINE YS(AW,RES,SIGMA)


C Calculation of Yield Strength of mechanically alloyed iron 
Copyright 1998, A. Y. Badmos and H. K. D. H. Bhadeshia
C University of Cambridge
C
C Materials Science and Technology, 1998, in press
C Ph.D. Thesis, A. Y. Badmos, University of Cambridge
C
C Committee model, neural network
C Uses file ALLINPUT,Y1WT, Y2WT, Y3WT, Y4WT, Y5WT


      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(14)
      DOUBLE PRECISION W1Y1(14,12),W2Y1(14),THETA1Y1(14)
      DOUBLE PRECISION W1Y2(10,12),W2Y2(10),THETA1Y2(10)
      DOUBLE PRECISION W1Y3(11,12),W2Y3(11),THETA1Y3(11)
      DOUBLE PRECISION W1Y4(16,12),W2Y4(16),THETA1Y4(16)
      DOUBLE PRECISION W1Y5(6,12),W2Y5(6),THETA1Y5(6),RES(26)
      DOUBLE PRECISION SIGMA
  




 
C General noise in data
      SIGMA=0.079
C Set number of inputs
      IN=12

C
C
      CALL YMOD1(X,AMIN,AMAX,THETA1Y1,THETA2Y1,W1Y1,W2Y1,AW,RES(1))
      CALL YMOD2(X,AMIN,AMAX,THETA1Y2,THETA2Y2,W1Y2,W2Y2,AW,RES(2))
      CALL YMOD3(X,AMIN,AMAX,THETA1Y3,THETA2Y3,W1Y3,W2Y3,AW,RES(3))
      CALL YMOD4(X,AMIN,AMAX,THETA1Y4,THETA2Y4,W1Y4,W2Y4,AW,RES(4))
      CALL YMOD5(X,AMIN,AMAX,THETA1Y5,THETA2Y5,W1Y5,W2Y5,AW,RES(5))

      DO 899 II=1,6
         IF(RES(II) .LT. 0.0D+00)RES(II)=0.0D+00
899   CONTINUE
  
      RES(6)=(RES(1)+RES(2)+RES(3)+RES(4)+RES(5))/5.0D+00  

      RETURN 
      END


C--------------------------------------------------------------------------

C Model1 Subroutine, it reads the weights and calculates elongation


      SUBROUTINE YMOD1(X,AMIN,AMAX,THETA1Y1,THETA2Y1,W1Y1,W2Y1,AW
     & ,YS1)               
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),YS1
      DOUBLE PRECISION W1Y1(14,12),W2Y1(14),THETA1Y1(14),H1(14)

C Set number of inputs
      IN=12
C
C
C Hidden units
      IHID=14
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="Y1WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1Y1(I)
C       WRITE(*,*)THETA1Y1(I)
        DO 4 J=1,IN
         READ(1,*)W1Y1(I,J)
C          WRITE(*,*)W1Y1(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2Y1
       DO 7 I=1,IHID
        READ(1,*)W2Y1(I)
C        WRITE(*,*)W2Y1(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-1
C
C First equation
C
       IHID=14

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1Y1(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H1(I)=DTANH(A+THETA1Y1(I))
C       WRITE(*,*)H1(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2Y1(I)*H1(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y1 = A+THETA2Y1

       YS1 = (Y1+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

      
        RETURN
	END
C--------------------------------------------------------------------------

C Model2 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE YMOD2(X,AMIN,AMAX,THETA1Y2,THETA2Y2,W1Y2,W2Y2,AW
     & ,YS2)               
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),YS2
      DOUBLE PRECISION W1Y2(10,12),W2Y2(10),THETA1Y2(10),H2(10)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=10
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="Y2WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1Y2(I)
C       WRITE(*,*)THETA1Y2(I)
        DO 4 J=1,IN
         READ(1,*)W1Y2(I,J)
C          WRITE(*,*)W1Y2(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2Y2
       DO 7 I=1,IHID
        READ(1,*)W2Y2(I)
C        WRITE(*,*)W2Y2(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-2
C
C First equation
C
       IHID=10

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1Y2(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H2(I)=DTANH(A+THETA1Y2(I))
C       WRITE(*,*)H1(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2Y2(I)*H2(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y2 = A+THETA2Y2

       YS2 = (Y2+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

  
        RETURN    
	END
C--------------------------------------------------------------------------

C Model3 Subroutine, it reads the weights and calculates elongation

       SUBROUTINE YMOD3(X,AMIN,AMAX,THETA1Y3,THETA2Y3,W1Y3,W2Y3,AW
     & ,YS3)  
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),YS3
      DOUBLE PRECISION W1Y3(11,12),W2Y3(11),THETA1Y3(11),H3(11)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=11
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="Y3WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1Y3(I)
C       WRITE(*,*)THETA1Y3(I)
        DO 4 J=1,IN
         READ(1,*)W1Y3(I,J)
C          WRITE(*,*)W1Y3(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2Y3
       DO 7 I=1,IHID
        READ(1,*)W2Y3(I)
C        WRITE(*,*)W2Y3(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-3
C
C First equation
C
       IHID=11

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1Y3(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H3(I)=DTANH(A+THETA1Y3(I))
C       WRITE(*,*)H3(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2Y3(I)*H3(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y3 = A+THETA2Y3

       YS3 = (Y3+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

        RETURN
	END
C--------------------------------------------------------------------------
C Model4 Subroutine, it reads the weights and calculates elongation

       SUBROUTINE YMOD4(X,AMIN,AMAX,THETA1Y4,THETA2Y4,W1Y4,W2Y4,AW
     & ,YS4)  
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),YS4
      DOUBLE PRECISION W1Y4(16,12),W2Y4(16),THETA1Y4(16),H4(16)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=16
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="Y4WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1Y4(I)
C       WRITE(*,*)THETA1Y4(I)
        DO 4 J=1,IN
         READ(1,*)W1Y4(I,J)
C          WRITE(*,*)W1Y4(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2Y4
       DO 7 I=1,IHID
        READ(1,*)W2Y4(I)
C        WRITE(*,*)W2Y4(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-4
C
C First equation
C
       IHID=16

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1Y4(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H4(I)=DTANH(A+THETA1Y4(I))
C       WRITE(*,*)H4(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2Y4(I)*H4(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y4 = A+THETA2Y4

       YS4 = (Y4+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

        RETURN
	END
C--------------------------------------------------------------------------

C Model5 Subroutine, it reads the weights and calculates elongation

       SUBROUTINE YMOD5(X,AMIN,AMAX,THETA1Y5,THETA2Y5,W1Y5,W2Y5,AW
     & ,YS5)  
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),YS5
      DOUBLE PRECISION W1Y5(6,12),W2Y5(6),THETA1Y5(6),H5(6)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=6
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="Y5WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1Y5(I)
C       WRITE(*,*)THETA1Y5(I)
        DO 4 J=1,IN
         READ(1,*)W1Y5(I,J)
C          WRITE(*,*)W1Y5(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2Y5
       DO 7 I=1,IHID
        READ(1,*)W2Y5(I)
C        WRITE(*,*)W2Y5(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-5
C
C First equation
C
       IHID=6

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1Y5(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H5(I)=DTANH(A+THETA1Y5(I))
C       WRITE(*,*)H5(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2Y5(I)*H5(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y5 = A+THETA2Y5

       YS5 = (Y5+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)


        RETURN
	END
C--------------------------------------------------------------------------
CC*****************************************************************************
      SUBROUTINE LOGO(AVER,IPAUSE)
      DOUBLE PRECISION AVER
      INTEGER IPAUSE
      WRITE(*,432)
432   FORMAT(//////////)
      WRITE(*,1)
1     FORMAT(
     &10X,' *************************************************',
     &'**********')
      WRITE(*,2)
2     FORMAT(10X,' **',55X,'**')
      WRITE(*,2)
      WRITE(*,430)
430      FORMAT(10X,' **      ',
     &  '  PROPERTIES OF MECHANICALLY ALLOYED IRON        **')
      WRITE(*,2)
      WRITE(*,431)AVER
431   FORMAT(10X,' **',10X,'           (Version ',F3.1,')   ',
     &,18X,'**')
      WRITE(*,2)
300   WRITE(*,2)
      WRITE(*,8)
8     FORMAT(10X,' **',8X,'                  by                  ',
     &9X,'**')
      WRITE(*,2)
      WRITE(*,9)
9     FORMAT(10X,' **',5X,' Adebayo Yeekeen Badmos & Harry Bhadeshia   ',
     &6X,'**')
      WRITE(*,2)
      WRITE(*,10)
10    FORMAT(10X,' **',8X,'        University of Cambridge       ',
     &9X,'**')
      WRITE(*,11)
11    FORMAT(10X,' **',8X,'                                      ',
     &9X,'**')
      WRITE(*,2)
      WRITE(*,2)
      WRITE(*,1)
      WRITE(*,433)
433   FORMAT(////)
      IF(IPAUSE .EQ. 1)PAUSE 'Press RETURN to continue'
      RETURN
      END
C*****************************************************************************
C********************************************************************************
C Copyright Dr H K D H Bhadeshia, University of Cambridge
C
C To read in the inputs
C
      SUBROUTINE RCOMP(C,J6)
C
      DOUBLE PRECISION C(14)
      INTEGER J6
C
      WRITE(*,700)
700   FORMAT(////19X,' Identification Number ?')
      CALL REEDI(J6)
      WRITE(*,707)
707   FORMAT(19X,' Chromium wt.% ?')
      CALL REED(C(1))
      IF(C(1) .LT. 13.0D+00 .OR. C(1) .GT. 20.0D+00)
     &CALL BOUND(C(1),13.0D+00,20.0D+00)
 
      WRITE(*,708)
      CALL REED(C(2))
      IF(C(2) .LT. 0.0D+00 .OR. C(2) .GT. 4.5D+00)
     &CALL BOUND(C(2),0.0D+00,4.5D+00)
708   FORMAT(19X,' Aluminium wt.% ?')
 
      WRITE(*,709)
      CALL REED(C(3))
      IF(C(3) .LT. 0.5D+00 .OR. C(3) .GT. 3.5D+00)
     &CALL BOUND(C(3),0.5D+00,3.5D+00)
709   FORMAT(19X,' Titanium wt.% ?')
 
      WRITE(*,710)
      CALL REED(C(4))
      IF(C(4) .LT. 0.0D+00 .OR. C(4) .GT. 1.5D+00)
     &CALL BOUND(C(4),0.0D+00,1.5D+00)
710   FORMAT(19X,' Molybdenum wt.% ?')
711   FORMAT(19X,' Yttria wt.% ?')
 
      WRITE(*,711)
      CALL REED(C(5))
      IF(C(5) .LT. 0.0D+00 .OR. C(5) .GT. 0.5D+00)
     &CALL BOUND(C(5),0.0D+00,0.5D+00)
712   FORMAT(19X,' Recrystallisation Temperature  C ?')
  
      WRITE(*,712)
      CALL REED(C(6))
      IF(C(6) .LT. 20.0D+00 .OR. C(6) .GT. 1330.0D+00)
     &CALL BOUND(C(6),20.0D+00,1330.0D+00)
713   FORMAT(19X,' Recrystallisation time, min ?')
  
      WRITE(*,713)
      CALL REED(C(7))
      IF(C(7) .LT. 0.0D+00 .OR. C(7) .GT. 120D+00)
     &CALL BOUND(C(7),0.0D+00,120D+00)

      WRITE(*,714)
      CALL REED(C(8))
      IF(C(8) .LT. 20D+00 .OR. C(8) .GT. 800D+00)
     &CALL BOUND(C(8),20D+00,800D+00)
714   FORMAT(19X,' Ageing temperature, C ?')


      WRITE(*,715)
      CALL REED(C(9))
      IF(C(8) .LT.  0D+00 .OR. C(9) .GT. 2888D+00)
     &CALL BOUND(C(9),0D+00,2888D+00)
715   FORMAT(19X,' Ageing time, min ?')


      WRITE(*,716)
      CALL REED(C(10))
      IF(C(10) .LT. 0D+00 .OR. C(10) .GT. 70D+00)
     &CALL BOUND(C(10),0D+00,70D+00)
716   FORMAT(19X,' % Cold work ?')


      WRITE(*,717)
      CALL REED(C(11))
      IF(C(11) .LT.  0D+00 .OR. C(11) .GT. 1250D+00)
     &CALL BOUND(C(11), 0D+00,1250D+00)
717   FORMAT(19X,' Test temperature, C ?')


      WRITE(*,718)
      CALL REED(C(12))
      IF(C(12) .LT. 3d-8 .OR. C(12) .GT. 3d-2)
     &CALL BOUND(C(12),3d-8,3d-2)
718   FORMAT(19X,'Strain rate, 1/s (e.g. 0.00003) ?')

C
       RETURN
       END
C************************************************************

C*****************************************************************************
      SUBROUTINE BOUND(A,B,C)
      DOUBLE PRECISION A,B,C,D
2      WRITE(*,1)B,C
1     FORMAT(12X,' Input value out of bounds'/
     &14X,' The limits are ',D12.4,' to ', D12.4///
     &14X,' Input new value, or 999 to continue with'/
     &14X,' original risky input                     ')
      CALL REED(D)
      IF(D .EQ. 999.0)GOTO 3
      A=D
      IF(A .LT. B .OR. A .GT. C)GOTO 2
3     RETURN
      END
C*********************************************************************
C*********************************************************************
      SUBROUTINE REED(A)
      DOUBLE PRECISION A
996   READ(*,*,ERR=999)A
          GOTO 998
999       WRITE(*,997)
997       FORMAT(19X,' Incorrect Input. Try again'/)
          GOTO 996
998   RETURN
      END
C*****************************************************************************
C*****************************************************************************
      SUBROUTINE REEDI(I)
      INTEGER I
996   READ(*,*,ERR=999)I
          GOTO 998
999       WRITE(*,997)
997       FORMAT(19X,' Incorrect Input. Try again'/)
          GOTO 996
998   RETURN
      END
C***********************************************************************

C********************************************************************
      SUBROUTINE WRITT(AW,ID,AVER)
      DOUBLE PRECISION AW(14),AVER 
      INTEGER ID
      WRITE(*,1)
1     FORMAT(
     &5X,' *************************************************',
     &'********************************')
 
      WRITE(*,4) ID,AVER,AW(1),AW(2),AW(3), AW(4),AW(5),AW(6),
     &  AW(7),AW(8),AW(9), AW(10),AW(11),AW(12)

4     FORMAT(//
     &14X,'**    Properties  of Mechanically Alloyed Iron **'//
     &20X,'         Cambridge University '/
     &20X,'         Badmos and Bhadeshia         '//
     &,11X'  Identification Number',I5,6X,
     &' Program Version ',F3.1 ///
     &10X,' Chromium   ',F6.3,'  wt.%',9X,' Aluminium   ',F6.3,'  wt.%'/
     &10X,' Titanium   ',F6.3,'  wt.%',9X,' Molybdenum  ',F6.3,'  wt.%'/
     &10X,' Yttria     ',F6.3,'  wt.%',9X//
     &10X,' Recrystallisation Temperature    ',F6.0,' C'/
     &10X,' Recrystallisation Time           ',F6.0,' min'/
     &10X,' Ageing Temperature               ',F6.0,' C'/
     &10X,' Ageing Time                      ',F6.0,' min'/
     &10X,' Cold Work                        ',F6.0,' %'/
     &10X,' Test Temperature                 ',F6.0,' C'/
     &10X,' Strain rate                      ',F7.5,' 1/s'/
     &//)
      RETURN
      END
C
C********************************************************************
      SUBROUTINE WRITT2(JYES)
      INTEGER JYES

       WRITE(*,4)
4     FORMAT(//
     &,5X,' THE VARIABLES:'//
     &,11X' Identification Number (1)'/
     &10X,' Chromium   ','  (2)',9X,' Aluminium   ','  (3)'/
     &10X,' Titanium   ','  (4)',9X,' Molybdenum  ','  (5)'/
     &10X,' Yttria     ','  (6)',9X//
     &10X,' Recrystallisation Temperature    ',' (7)'/
     &10X,' Recrystallisation Time           ',' (8)'/
     &10X,' Ageing Temperature               ',' (9)'/
     &10X,' Ageing Time                      ',' (10)'/
     &10X,' Cold Work                        ',' (11)'/
     &10X,' Test Temperature                 ',' (12)'/
     &10X,' Strain rate                      ',' (13)'/
     &//)
      WRITE(*,1) 
1     FORMAT(//' Number of variable to be changed?'/)
      CALL REEDI(JYES)
      RETURN
      END
C
C********************************************************************
      SUBROUTINE UTS(AW,RES,SIGMA)

C Calculation of Ultimate Tensile strength of mechanically alloyed iron 
Copyright 1998, A. Y. Badmos and H. K. D. H. Bhadeshia
C University of Cambridge
C
C Materials Science and Technology, 1998, in press
C Ph.D. Thesis, A. Y. Badmos, University of Cambridge
C
C Committee model, neural network
C Uses file ALLINPUT,U1WT, U2WT, U3WT


      
  
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(14)
      DOUBLE PRECISION W1U1(16,12),W2U1(16),THETA1U1(16)
      DOUBLE PRECISION W1U2(15,12),W2U2(15),THETA1U2(15)
      DOUBLE PRECISION W1U3(15,12),W2U3(15),THETA1U3(15),RES(26)
      DOUBLE PRECISION SIGMA


 
C General noise in data
      SIGMA=0.074
C Set number of inputs
      IN=12
C
C
C
      CALL UMOD1(X,AMIN,AMAX,THETA1U1,THETA2U1,W1U1,W2U1,AW,RES(1))
      CALL UMOD2(X,AMIN,AMAX,THETA1U2,THETA2U2,W1U2,W2U2,AW,RES(2))
      CALL UMOD3(X,AMIN,AMAX,THETA1U3,THETA2U3,W1U3,W2U3,AW,RES(3))

      DO 899 II=1,4
         IF(RES(II) .LT. 0.0D+00)RES(II)=0.0D+00
899   CONTINUE
  
      RES(4)=(RES(1)+RES(2)+RES(3))/3.0D+00  

       RETURN
       END



C--------------------------------------------------------------------------

C Model1 Subroutine, it reads the weights and calculates elongation


      SUBROUTINE UMOD1(X,AMIN,AMAX,THETA1U1,THETA2U1,W1U1,W2U1,AW
     & ,UTS1)               
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),UTS1
      DOUBLE PRECISION W1U1(16,12),W2U1(16),THETA1U1(16),H1(16)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=16
c
C READ WEIGHTS FROM NEURAL NETWORK

      OPEN(UNIT=1, FILE="U1WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1U1(I)
C       WRITE(*,*)THETA1U1(I)
        DO 4 J=1,IN
         READ(1,*)W1U1(I,J)
C          WRITE(*,*)W1U1(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2U1
       DO 7 I=1,IHID
        READ(1,*)W2U1(I)
C        WRITE(*,*)W2U1(I)
C
7     CONTINUE

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00

C      WRITE(*,*)X(I)
202     CONTINUE

C Calculation with model-1
C
C First equation
C
       IHID=16

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1U1(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H1(I)=DTANH(A+THETA1U1(I))
C       WRITE(*,*)H1(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2U1(I)*H1(I)
C      WRITE(*,*)A 
60      CONTINUE
C
       Y1 = A+THETA2U1

       UTS1 = (Y1+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

      
        RETURN
	END
C--------------------------------------------------------------------------

C Model2 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE UMOD2(X,AMIN,AMAX,THETA1U2,THETA2U2,W1U2,W2U2,AW
     & ,UTS2)               
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),UTS2
      DOUBLE PRECISION W1U2(15,12),W2U2(15),THETA1U2(15),H2(15)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=15
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="U2WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1U2(I)
C       WRITE(*,*)THETA1U2(I)
        DO 4 J=1,IN
         READ(1,*)W1U2(I,J)
C          WRITE(*,*)W1U2(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2U2
       DO 7 I=1,IHID
        READ(1,*)W2U2(I)
C        WRITE(*,*)W2U2(I)
C
7     CONTINUE


C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-2
C
C First equation
C
       IHID=15

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1U2(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H2(I)=DTANH(A+THETA1U2(I))
C       WRITE(*,*)H2(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2U2(I)*H2(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y2 = A+THETA2U2

       UTS2 = (Y2+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)

  
        RETURN    
	END
C--------------------------------------------------------------------------

C Model3 Subroutine, it reads the weights and calculates elongation

       SUBROUTINE UMOD3(X,AMIN,AMAX,THETA1U3,THETA2U3,W1U3,W2U3,AW
     & ,UTS3)  
      DOUBLE PRECISION X(12),AMIN(13),AMAX(13),AW(12),UTS3
      DOUBLE PRECISION W1U3(15,12),W2U3(15),THETA1U3(15),H3(15)

C Set number of inputs
      IN=12
C
C Hidden units
      IHID=15
C
C READ WEIGHTS FROM NEURAL NETWORK
C
      OPEN(UNIT=1, FILE="U3WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMIN(I),AMAX(I)
C         WRITE(*,*)IDUM,AMIN(I),AMAX(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1U3(I)
C       WRITE(*,*)THETA1U3(I)
        DO 4 J=1,IN
         READ(1,*)W1U3(I,J)
C          WRITE(*,*)W1U3(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2U3
       DO 7 I=1,IHID
        READ(1,*)W2U3(I)
C        WRITE(*,*)W2U3(I)
C
7     CONTINUE

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMIN(I))/(AMAX(I)-AMIN(I)))-0.5D+00
C      WRITE(*,*)X(I)
202     CONTINUE
C

C Calculation with model-3
C
C First equation
C
       IHID=15

       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1U3(I,J)*X(J)
C            WRITE(*,*)A 
29              CONTINUE
 
        H3(I)=DTANH(A+THETA1U3(I))
C       WRITE(*,*)H3(I) 
28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2U3(I)*H3(I)
C       WRITE(*,*)A 
60      CONTINUE
C
       Y3 = A+THETA2U3

       UTS3 = (Y3+0.5D+00)*(AMAX(IN+1)-AMIN(IN+1))+AMIN(IN+1)


        RETURN
	END
C--------------------------------------------------------------------------
      SUBROUTINE ELONGATION(AW,RES,SIGMA)

C Calculation of elongation of mechanically alloyed iron 
Copyright 1998, A. Y. Badmos and H. K. D. H. Bhadeshia
C University of Cambridge
C
C Materials Science and Technology, 1998, in press
C Ph.D. Thesis, A. Y. Badmos, University of Cambridge
C
C Committee model, neural network
C Uses file ALLINPUT,E1WT, E2WT, E3WT, E4WT, E5WT, E6WT


      
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14)
      DOUBLE PRECISION W1E1(14,14),W2E1(14),THETA1E1(14)
      DOUBLE PRECISION W1E2(14,14),W2E2(14),THETA1E2(14)
      DOUBLE PRECISION W1E3(11,14),W2E3(11),THETA1E3(11)
      DOUBLE PRECISION W1E4(13,14),W2E4(13),THETA1E4(13)
      DOUBLE PRECISION W1E5(8,14),W2E5(8),THETA1E5(8)
      DOUBLE PRECISION W1E6(7,14),W2E6(7),THETA1E6(7),RES(26)
      DOUBLE PRECISION SIGMA


 
C General noise in data
      SIGMA=0.132
C Set number of inputs
      IN=14
C

C
C
      CALL ELMOD1(X,AMINEL,AMAXEL,THETA1E1,THETA2E1,W1E1,W2E1,AW,RES(1))
      CALL ELMOD2(X,AMINEL,AMAXEL,THETA1E2,THETA2E2,W1E2,W2E2,AW,RES(2))
      CALL ELMOD3(X,AMINEL,AMAXEL,THETA1E3,THETA2E3,W1E3,W2E3,AW,RES(3))
      CALL ELMOD4(X,AMINEL,AMAXEL,THETA1E4,THETA2E4,W1E4,W2E4,AW,RES(4))
      CALL ELMOD5(X,AMINEL,AMAXEL,THETA1E5,THETA2E5,W1E5,W2E5,AW,RES(5))
      CALL ELMOD6(X,AMINEL,AMAXEL,THETA1E6,THETA2E6,W1E6,W2E6,AW,RES(6))

      do 899 ii=1,7
         if(res(ii) .lt. 0.0d+00)res(ii)=0.0d+00
899   continue
  
      RES(7)=(RES(1)+RES(2)+RES(3)+RES(4)+RES(5)+RES(6))/6.0D+00 
       
       RETURN
       END


C--------------------------------------------------------------------------

C Model1 Subroutine, it reads the weights and calculates elongation


      SUBROUTINE ELMOD1(X,AMINEL,AMAXEL,THETA1E1,THETA2E1,W1E1,W2E1,AW
     & ,EL1)               
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL1
      DOUBLE PRECISION W1E1(14,14),W2E1(14),THETA1E1(14),H1(14)

C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-1 

C Hidden units
      IHID=14

      OPEN(UNIT=1, FILE="E1WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E1(I)
C       WRITE(*,*)THETA1E1(I)
        DO 4 J=1,IN
         READ(1,*)W1E1(I,J)
C         WRITE(*,*)W1E1(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E1
       DO 7 I=1,IHID
        READ(1,*)W2E1(I)
C        WRITE(*,*)W2E1(I)
C
7     CONTINUE
C

C Normalize the input variables
     
      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE


C CALCULATIONS USING THE DIFFERENT MODELS

C Calculation with model-1
C
C First equation
C
       IHID=14
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E1(I,J)*X(J)
              
29              CONTINUE
 
        H1(I)=DTANH(A+THETA1E1(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E1(I)*H1(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y1 = A+THETA2E1

       EL1 = (Y1+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)
      
        RETURN
	END
C--------------------------------------------------------------------------

C Model2 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE ELMOD2(X,AMINEL,AMAXEL,THETA1E2,THETA2E2,W1E2,W2E2,AW
     & ,EL2)  
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL2
      DOUBLE PRECISION W1E2(14,14),W2E2(14),THETA1E2(14),H1(14)
      OPEN(UNIT=2,FILE="ELONG")      
      OPEN(UNIT=3,FILE="ALLOUTPUT")
C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-2 

C Hidden units
      IHID=14

      OPEN(UNIT=1, FILE="E2WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E2(I)
C       WRITE(*,*)THETA1E2(I)
        DO 4 J=1,IN
         READ(1,*)W1E2(I,J)
C         WRITE(*,*)W1E2(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E2
       DO 7 I=1,IHID
        READ(1,*)W2E2(I)
C        WRITE(*,*)W2E2(I)
C
7     CONTINUE
C

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE



C Calculation with model-2
C
C First equation
C
       IHID=14
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E2(I,J)*X(J)
              
29              CONTINUE
 
        H1(I)=DTANH(A+THETA1E2(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E2(I)*H1(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y2 = A+THETA2E2

       EL2 = (Y2+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)

  
        RETURN    
	END
C--------------------------------------------------------------------------

C Model3 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE ELMOD3(X,AMINEL,AMAXEL,THETA1E3,THETA2E3,W1E3,W2E3,AW
     & ,EL3)   
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL3
      DOUBLE PRECISION W1E3(11,14),W2E3(11),THETA1E3(11),H1(11)
C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-3 

C Hidden units
      IHID=11

      OPEN(UNIT=1, FILE="E3WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E3(I)
C       WRITE(*,*)THETA1E3(I)
        DO 4 J=1,IN
         READ(1,*)W1E3(I,J)
C         WRITE(*,*)W1E3(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E3
       DO 7 I=1,IHID
        READ(1,*)W2E3(I)
C        WRITE(*,*)W2E3(I)
C
7     CONTINUE
C

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE


C Calculation with model-3
C
C First equation
C
       IHID=11
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E3(I,J)*X(J)
              
29              CONTINUE
 
        H1(I)=DTANH(A+THETA1E3(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E3(I)*H1(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y3 = A+THETA2E3

       EL3 = (Y3+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)

        RETURN
	END
C--------------------------------------------------------------------------
C Model4 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE ELMOD4(X,AMINEL,AMAXEL,THETA1E4,THETA2E4,W1E4,W2E4,AW
     & ,EL4)   
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL4
      DOUBLE PRECISION W1E4(13,14),W2E4(13),THETA1E4(13),H4(13)
C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-4 

C Hidden units
      IHID=13

      OPEN(UNIT=1, FILE="E4WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E4(I)
C       WRITE(*,*)THETA1E4(I)
        DO 4 J=1,IN
         READ(1,*)W1E4(I,J)
C         WRITE(*,*)W1E4(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E4
       DO 7 I=1,IHID
        READ(1,*)W2E4(I)
C        WRITE(*,*)W2E4(I)
C
7     CONTINUE
C

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE


C Calculation with model-4
C
C First equation
C
       IHID=13
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E4(I,J)*X(J)
              
29              CONTINUE
 
        H4(I)=DTANH(A+THETA1E4(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E4(I)*H4(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y4 = A+THETA2E4

       EL4 = (Y4+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)

        RETURN
	END
C--------------------------------------------------------------------------

C Model5 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE ELMOD5(X,AMINEL,AMAXEL,THETA1E5,THETA2E5,W1E5,W2E5,AW
     & ,EL5)  
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL5
      DOUBLE PRECISION W1E5(8,14),W2E5(8),THETA1E5(8),H5(8)
C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-5 

C Hidden units
      IHID=8

      OPEN(UNIT=1, FILE="E5WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E5(I)
C       WRITE(*,*)THETA1E5(I)
        DO 4 J=1,IN
         READ(1,*)W1E5(I,J)
C         WRITE(*,*)W1E5(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E5
       DO 7 I=1,IHID
        READ(1,*)W2E5(I)
C        WRITE(*,*)W2E5(I)
C
7     CONTINUE
C

C Normalize the input variables


      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE


C Calculation with model-5
C
C First equation
C
       IHID=8
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E5(I,J)*X(J)
              
29              CONTINUE
 
        H5(I)=DTANH(A+THETA1E5(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E5(I)*H5(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y5 = A+THETA2E5

       EL5 = (Y5+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)

        RETURN
	END
C--------------------------------------------------------------------------

C Model6 Subroutine, it reads the weights and calculates elongation

      SUBROUTINE ELMOD6(X,AMINEL,AMAXEL,THETA1E6,THETA2E6,W1E6,W2E6,AW
     &  ,EL6)   
      DOUBLE PRECISION X(14),AMINEL(15),AMAXEL(15),AW(14),EL6
      DOUBLE PRECISION W1E6(7,14),W2E6(7),THETA1E6(7),H6(7)
      INTEGER I
C Set number of inputs
      IN=14
C
C
C READ WEIGHTS FROM NEURAL NETWORK WEIGHT FILES

C   Model-6 

C Hidden units
      IHID=7

      OPEN(UNIT=1, FILE="E6WT")
       DO 2 I=1,IN+1
        READ(1,*)IDUM,AMINEL(I),AMAXEL(I)
C        WRITE(*,*)IDUM,AMINEL(I),AMAXEL(I)
2     CONTINUE
C
      DO 3 I=1,IHID
       READ(1,*)THETA1E6(I)
C       WRITE(*,*)THETA1E6(I)
        DO 4 J=1,IN
         READ(1,*)W1E6(I,J)
C         WRITE(*,*)W1E6(I,J)
4       CONTINUE
3     CONTINUE
C     
      READ(1,*)THETA2E6
       DO 7 I=1,IHID
        READ(1,*)W2E6(I)
C        WRITE(*,*)W2E6(I)
C
7     CONTINUE
C

C Normalize the input variables

      DO 202 I=1,IN
       X(I)=((AW(I) -AMINEL(I))/(AMAXEL(I)-AMINEL(I)))-0.5D+00
C      WRITE(*,40)X(I)
202     CONTINUE


C Calculation with model-6
C
C First equation
C
       IHID=7
       DO 28 I=1,IHID
          A=0.0D+00
C
               DO 29 J=1,IN
                 A=A+W1E6(I,J)*X(J)
              
29              CONTINUE
 
        H6(I)=DTANH(A+THETA1E6(I))

28      CONTINUE
C
C Second equation
C
       A=0.0D+00
       DO 60 I=1,IHID
          A=A+W2E6(I)*H6(I)
C       WRITE(*,*)A
60      CONTINUE
C
       Y6 = A+THETA2E6

       EL6 = (Y6+0.5D+00)*(AMAXEL(IN+1)-AMINEL(IN+1))+AMINEL(IN+1)
        
        RETURN
	END
C********************************************************************************
C Copyright Dr H K D H Bhadeshia, University of Cambridge
C
C To read in the inputs
C
      SUBROUTINE RCOMP2(C,JYES,IYES)
C
      DOUBLE PRECISION C(14)
      INTEGER JYES,IYES

      WRITE(*,24)
24    FORMAT(/////////////
     &30X,' 1 = Revise input data'/
     &30X,' 2 = Main menu        '/
     &30X,' 0 = Stop program     '/)

      CALL REEDI(IYES)

      IF(IYES .NE. 1)GOTO 14

      CALL WRITT2(JYES)

C
      IF(JYES .ne. 1) GOTO 2
      WRITE(*,700)
700   FORMAT(////19X,' Identification Number ?')
      CALL REEDI(J6)
      GOTO 14

2     IF(JYES .ne. 2) GOTO 3
      WRITE(*,707)
707   FORMAT(19X,' Chromium wt.% ?')
      CALL REED(C(1))
      IF(C(1) .LT. 13.0D+00 .OR. C(1) .GT. 20.0D+00)
     &CALL BOUND(C(1),13.0D+00,20.0D+00)
      GOTO 14

3     IF(JYES .ne. 3) GOTO 4 
      WRITE(*,708)
      CALL REED(C(2))
      IF(C(2) .LT. 0.0D+00 .OR. C(2) .GT. 4.5D+00)
     &CALL BOUND(C(2),0.0D+00,4.5D+00)
708   FORMAT(19X,' Aluminium wt.% ?')
      GOTO 14

4     IF(JYES .ne. 4) GOTO 5
      WRITE(*,709)
      CALL REED(C(3))
      IF(C(3) .LT. 0.5D+00 .OR. C(3) .GT. 3.5D+00)
     &CALL BOUND(C(3),0.5D+00,3.5D+00)
709   FORMAT(19X,' Titanium wt.% ?')
      GOTO 14
 
5     IF(JYES .ne. 5) GOTO 6
      WRITE(*,710)
      CALL REED(C(4))
      IF(C(4) .LT. 0.0D+00 .OR. C(4) .GT. 1.5D+00)
     &CALL BOUND(C(4),0.0D+00,1.5D+00)
710   FORMAT(19X,' Molybdenum wt.% ?')
      GOTO 14

 
6     IF(JYES .ne. 6) GOTO 7
      WRITE(*,711)
      CALL REED(C(5))
      IF(C(5) .LT. 0.0D+00 .OR. C(5) .GT. 0.5D+00)
     &CALL BOUND(C(5),0.0D+00,0.5D+00)
711   FORMAT(19X,' Yttria wt.% ?')
      GOTO 14

7     IF(JYES .ne. 7) GOTO 8  
      WRITE(*,712)
      CALL REED(C(6))
      IF(C(6) .LT. 20.0D+00 .OR. C(6) .GT. 1330.0D+00)
     &CALL BOUND(C(6),20.0D+00,1330.0D+00)
712   FORMAT(19X,' Recrystallisation Temperature  C ?')
      GOTO 14
  
8     IF(JYES .ne. 8) GOTO 9  
      WRITE(*,713)
      CALL REED(C(7))
      IF(C(7) .LT. 0.0D+00 .OR. C(7) .GT. 120D+00)
     &CALL BOUND(C(7),0.0D+00,120D+00)
713   FORMAT(19X,' Recrystallisation time, min ?')
      GOTO 14

9     IF(JYES .ne. 9) GOTO 10 
      WRITE(*,714)
      CALL REED(C(8))
      IF(C(8) .LT. 20D+00 .OR. C(8) .GT. 800D+00)
     &CALL BOUND(C(8),20D+00,800D+00)
714   FORMAT(19X,' Ageing temperature, C ?')
      GOTO 14

10    IF(JYES .ne. 10) GOTO 11 
      WRITE(*,715)
      CALL REED(C(9))
      IF(C(8) .LT.  0D+00 .OR. C(9) .GT. 2888D+00)
     &CALL BOUND(C(9),0D+00,2888D+00)
715   FORMAT(19X,' Ageing time, min ?')
      GOTO 14


11    IF(JYES .ne. 11) GOTO 12 
      WRITE(*,716)
      CALL REED(C(10))
      IF(C(10) .LT. 0D+00 .OR. C(10) .GT. 70D+00)
     &CALL BOUND(C(10),0D+00,70D+00)
716   FORMAT(19X,' % Cold work ?')
      GOTO 14


12    IF(JYES .ne. 12) GOTO 13 
      WRITE(*,717)
      CALL REED(C(11))
      IF(C(11) .LT.  0D+00 .OR. C(11) .GT. 1250D+00)
     &CALL BOUND(C(11), 0D+00,1250D+00)
717   FORMAT(19X,' Test temperature, C ?')
      GOTO 14

13    IF(JYES .ne. 13) GOTO 14 

      WRITE(*,718)
      CALL REED(C(12))
      IF(C(12) .LT. 3d-8 .OR. C(12) .GT. 3d-2)
     &CALL BOUND(C(12),3d-8,3d-2)
718   FORMAT(19X,'Strain rate, 1/s (e.g. 0.00003) ?')

C
14     RETURN
       END
C************************************************************

